
/** Common Enemy Tools **/

function eFallBack(args: Array<Dynamic>) : Void
{
	var self: Enemy = args[0];
	var t: Float = args[1];
	
	if (t == 1)
		self.nextAction();
	else
		self.vy += GameScene.levelSpeed;
}

function eMoveEase(args: Array<Dynamic>) : Bool
{
	var self: Enemy = args[0];
	var sx: Float = args[1];
	var sy: Float = args[2];
	var tox: Float = args[3];
	var toy: Float = args[4];
	var t: Float = args[5];
	
	self.vx = sx + (tox - sx) * Ease.sineInOut(t);
	self.vy = sy + (toy - sy) * Ease.sineInOut(t);
	
	return t >= 1;
}

function eGetDodge(args: Array<Dynamic>) : Float //returns x of projected collision
{
	var self: Enemy = args[0];
	var space: Float = Level.TILE_SIZE;
	var ahead: Float = space * args[1];
	var sidestep: Float = 0;
	var freeL: Bool = false; // free to move left
	var freeR: Bool = false; // free to move right
	
	do
	{
		var partHitL: Bool = false; // if there's a hit on the left sidestep at least once
		var partHitR: Bool = false; // if there's a hit on the right sidestep at least once
		for (type in self.dodgeThese)
		{
			if (!freeL)
				if (self.collide(type, self.x - sidestep, self.y + ahead) != null)
					partHitL = true;
			
			if (!freeR)
				if (self.collide(type, self.x + sidestep, self.y + ahead) != null)
					partHitR = true;
		}
		
		if (!partHitL)
			freeL = true;
		if (!partHitR)
			freeR = true;
		
		if (!freeL && !freeR)
			sidestep += space;
	}
	while (!freeL && !freeR)
	
	var absL: Float = freeL ? sidestep : Math.POSITIVE_INFINITY;
	var absR: Float = freeR ? sidestep : Math.POSITIVE_INFINITY;
	
	return Math.min(absL, absR) == absL ? sidestep : -sidestep;
}

/** Common Projectile Tools **/

function pMoveDir(args: Array<Dynamic>) : Void
{
	var self: Projectile = args[0];
	self.vx += Math.cos(self.direction) * self.speed;
	self.vy += Math.sin(self.direction) * self.speed;
}
